//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiFoyer {

    /** Permet de récupérer l'ensemble des voisins du user en fonction du delta */
    public enum GetApiFoyerGetVoisinage {

        public static let service = APIService<Response>(id: "getApiFoyerGetVoisinage", tag: "Api Foyer", method: "GET", path: "/apiFoyer/getVoisinage", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var idFoyer: String

                public var delta: Int

                public init(idFoyer: String, delta: Int) {
                    self.idFoyer = idFoyer
                    self.delta = delta
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: GetApiFoyerGetVoisinage.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(idFoyer: String, delta: Int) {
                let options = Options(idFoyer: idFoyer, delta: delta)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["idFoyer"] = options.idFoyer
                params["delta"] = options.delta
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = [Foyer]

            /** Succes */
            case status200([Foyer])

            public var success: [Foyer]? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
